package jp.co.ipride.excat.sample.filter;

import java.io.IOException;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

public class SetCharacterEncodingFilter implements Filter {


	private static final String THRU_FILTER_KEY = "THRU_FILTER_ENCODING";

	private boolean moreFlag = false;

	private String encoding = null;

	private boolean ignoreFlag = false;

	public void init(FilterConfig filterConfig) throws ServletException {

		this.encoding = filterConfig.getInitParameter("encoding");


		String ignoreValue = filterConfig.getInitParameter("ignore");
		if (ignoreValue != null) {
			this.ignoreFlag = this.createFlag(ignoreValue);
		}

		String moreValue = filterConfig.getInitParameter("more");
		if (moreValue != null) {
			this.moreFlag = this.createFlag(moreValue);
		}
	}

	public void doFilter(ServletRequest request, ServletResponse response,
			FilterChain chain) throws IOException, ServletException {

		if (!this.moreFlag && request.getAttribute(THRU_FILTER_KEY) != null) {
			chain.doFilter(request, response);
			return;
		}

		if (!ignoreFlag && encoding != null) {
			request.setCharacterEncoding(encoding);
		}
		request.setAttribute(THRU_FILTER_KEY, THRU_FILTER_KEY);

		chain.doFilter(request, response);
	}
	public void destroy() {
		this.encoding = null;
	}

	private boolean createFlag(String value) {
		if ("true".equalsIgnoreCase(value)) {
			return true;
		} else if ("yes".equalsIgnoreCase(value)) {
			return true;
		}
		return false;
	}
}
